//this file is part of eMule
//Copyright (C)2002 Merkur ( merkur-@users.sourceforge.net / http://www.emule-project.net )
//
//This program is free software; you can redistribute it and/or
//modify it under the terms of the GNU General Public License
//as published by the Free Software Foundation; either
//version 2 of the License, or (at your option) any later version.
//
//This program is distributed in the hope that it will be useful,
//but WITHOUT ANY WARRANTY; without even the implied warranty of
//MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//GNU General Public License for more details.
//
//You should have received a copy of the GNU General Public License
//along with this program; if not, write to the Free Software
//Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

#include "StdAfx.h"
#include "updownclient.h"
#include "emule.h"
#include "uploadqueue.h"
#include "Clientlist.h"
#include "SearchList.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//[Bloodymad@LSD ModIdentify.Receive]
#ifdef _DEBUG
#define NODEBUGelse 
#else
#define NODEBUGelse else
#endif

//	members of CUpDownClient
//	which are used by down and uploading functions 

CUpDownClient::CUpDownClient(CClientReqSocket* sender){
	socket = sender;
	reqfile = 0;
	Init();
}

CUpDownClient::CUpDownClient(uint16 in_port, uint32 in_userid,uint32 in_serverip, uint16 in_serverport,CPartFile* in_reqfile){
	socket = 0;
	Init();
	m_nUserID = in_userid;
	m_nUserPort = in_port;
	sourcesslot=m_nUserID%SOURCESSLOTS;
	if (!HasLowID())
		sprintf(m_szFullUserIP,"%i.%i.%i.%i",(uint8)m_nUserID,(uint8)(m_nUserID>>8),(uint8)(m_nUserID>>16),(uint8)(m_nUserID>>24));
	m_dwServerIP = in_serverip;
	m_nServerPort = in_serverport;
	reqfile = in_reqfile;
	ReGetClientSoft();
	//[Bloodymad@LSD ModIdentify.Receive]
	ReGetClientName();
}

void CUpDownClient::Init(){
	memset(m_szFullUserIP,0,21);
	credits = 0;
	sumavgDDR = 0; // By BadWolf - Accurate Speed Measurement
	sumavgUDR = 0; // by BadWolf - Accurate Speed Measurement
	m_bAddNextConnect = false;  // VQB Fix for LowID slots only on connection
	m_nAvDownDatarate = 0;
	m_nAvUpDatarate = 0;
	m_nChatstate = MS_NONE;
	m_cShowDR = 0;
	m_nUDPPort = 0;
	m_cFailed = 0;
	m_nMaxSendAllowed = 0;
	m_nTransferedUp = 0;
	m_cSendblock = 0;
	m_cAsked = 0;
	m_cDownAsked = 0;
	dataratems = 0;
	m_nUpDatarate = 0;
	m_pszUsername = 0;
	m_dwUserIP = 0;
	m_nUserID = 0;
	m_nServerPort = 0;
    m_iFileListRequested = 0;
	m_dwLastUpRequest = 0;
	m_bEmuleProtocol = false;
	usedcompressiondown = false;
	m_bUsedComprUp = false;
	m_bCompleteSource = false;
	m_bFriendSlot = false;
	m_bCommentDirty = false;
	m_bReaskPending = false;
	m_bUDPPending = false;
	m_byEmuleVersion = 0;
	m_nUserPort = 0;
	m_nPartCount = 0;
	m_nUpPartCount = 0;
	m_abyPartStatus = 0;
	m_abyUpPartStatus = 0;
	m_dwLastAskedTime = 0;
	m_nDownloadState = DS_NONE;
	m_dwUploadTime = 0;
	m_nTransferedDown = 0;
	m_nDownDatarate = 0;
	m_nDownDataRateMS = 0;
	m_nUploadState = US_NONE;
	m_dwLastBlockReceived = 0;
	m_byEmuleVersion = 0;
	m_byDataCompVer = 0;
	m_byUDPVer = 0;
	m_bySourceExchangeVer = 0;
	m_byAcceptCommentVer = 0;
	m_byExtendedRequestsVer = 0;
	m_nRemoteQueueRank = 0;
	m_dwLastSourceRequest = 0;
	m_dwLastSourceAnswer = 0;
	m_dwLastAskedForSources = 0;
	m_byCompatibleClient = 0;
	m_bIsHybrid = false;
	m_bIsML=false;
	m_Friend = NULL;
	m_iRate=0;
	m_bMsgFiltered=false;
	m_strComment="";
	m_nCurSessionUp = 0;
	m_nSumForAvgDownDataRate = 0;
	m_nSumForAvgUpDataRate = 0;
	m_clientSoft=SO_UNKNOWN;
	m_bRemoteQueueFull = false;
	md4clr(m_achUserHash);

	//[Bloodymad Featureset.Receive]
	m_byFeatureSet = 0;
	//[Bloodymad@Vorlost Anti-Friendsharing 0.3]
	m_bIsFriendsharingClient = false;
	//[Bloodymad@LSD ModIdentify.Receive]
	//m_versionMod = 0;
	m_versionModString = NULL;
	m_versionString = nstrdup(GetResString(IDS_UNKNOWN).GetBuffer());
	//[Bloodymad UsageLog]
	anonymousid = nextanonymousid++;
	theApp.usagelog->LogLine("NewClient","id=%u;",anonymousid);
	//[Bloodymad ChunkSelection]
	LastPartAsked = -1;

	if (socket){
		SOCKADDR_IN sockAddr;
		memset(&sockAddr, 0, sizeof(sockAddr));
		uint32 nSockAddrLen = sizeof(sockAddr);
		socket->GetPeerName((SOCKADDR*)&sockAddr,(int*)&nSockAddrLen);
		m_dwUserIP = sockAddr.sin_addr.S_un.S_addr;
		strcpy(m_szFullUserIP,inet_ntoa(sockAddr.sin_addr));
	}
	sourcesslot=0;
	m_fHashsetRequesting = 0;
	m_fSharedDirectories = 0;
	md4clr(requpfileid);
	m_nClientVersion = 0;
	m_dwEnteredConnectedState = 0;
	m_lastRefreshedDLDisplay = 0;

	m_SecureIdentState = IS_UNAVAILABLE;
	m_dwLastSignatureIP = 0;
	m_bySupportSecIdent = 0;
	m_byInfopacketsReceived = IP_NONE;
	m_bIsSpammer = false;
	m_cMessagesReceived = 0;
	m_cMessagesSend = 0;
	m_lastPartAsked = 0xffff;
}

CUpDownClient::~CUpDownClient(){
	theApp.clientlist->RemoveClient(this);
	if (m_Friend){
		m_Friend->m_LinkedClient = NULL;
		theApp.friendlist->RefreshFriend(m_Friend);
		m_Friend = NULL;
	}
	if (socket){
		socket->client = 0;
		socket->Safe_Delete();
	}
	if (m_pszUsername)
		delete[] m_pszUsername;
	if (m_abyPartStatus)
		delete[] m_abyPartStatus;
	if (m_abyUpPartStatus)
		delete[] m_abyUpPartStatus;
	ClearUploadBlockRequests();

	for (POSITION pos = m_DownloadBlocks_list.GetHeadPosition();pos != 0;m_DownloadBlocks_list.GetNext(pos))
		delete m_DownloadBlocks_list.GetAt(pos);
	m_DownloadBlocks_list.RemoveAll();
	for (POSITION pos = m_RequestedFiles_list.GetHeadPosition();pos != 0;m_RequestedFiles_list.GetNext(pos))
		delete m_RequestedFiles_list.GetAt(pos);
	m_RequestedFiles_list.RemoveAll();
	for (POSITION pos = m_PendingBlocks_list.GetHeadPosition();pos != 0;m_PendingBlocks_list.GetNext(pos)){
		Pending_Block_Struct *pending = m_PendingBlocks_list.GetAt(pos);
		delete pending->block;
		// Not always allocated
		if (pending->zStream){
			inflateEnd(pending->zStream);
			delete pending->zStream;
		}
		delete pending;
	}

	if (m_iRate>0 || m_strComment.GetLength()>0) {
		m_iRate=0; m_strComment="";
		reqfile->UpdateFileRatingCommentAvail();
	}

	m_PendingBlocks_list.RemoveAll();
	m_AvarageUDR_list.RemoveAll();
	m_AvarageDDR_list.RemoveAll();
	DEBUG_ONLY (theApp.listensocket->Debug_ClientDeleted(this));
	this->SetUploadFileID(NULL);

	//[Bloodymad@LSD ModIdentify.Receive]
	if (m_versionString)
		EMPTYARR(m_versionString);
	if (m_versionModString)
		EMPTYARR(m_versionModString);
}

void CUpDownClient::ProcessHelloPacket(char* pachPacket, uint32 nSize){
	CSafeMemFile data((BYTE*)pachPacket,nSize);
	uint8 hashsize;
	data.Read(&hashsize,1);
	ProcessHelloTypePacket(&data);
}

void CUpDownClient::ProcessHelloAnswer(char* pachPacket, uint32 nSize){
	CSafeMemFile data((BYTE*)pachPacket,nSize);
	ProcessHelloTypePacket(&data);
}

void CUpDownClient::ProcessHelloTypePacket(CSafeMemFile* data){
	
	m_bIsHybrid = false;
	m_bIsML = false;
	data->Read(&m_achUserHash,16);
	data->Read(&m_nUserID,4);
	uint16 nUserPort = 0;
	data->Read(&nUserPort,2); // hmm clientport is sent twice - why?

	uint32 tagcount;
	data->Read(&tagcount,4);
	for (uint32 i = 0;i < tagcount; i++){
		CTag temptag(data);
		switch(temptag.tag.specialtag){
			case CT_NAME:
				//[Bloodymad General]
				//[Bloodymad NickGenerator]
				SetUserName(temptag.tag.stringvalue);
				break;
			case CT_VERSION:
				m_nClientVersion = temptag.tag.intvalue;
				break;
			case CT_PORT:
				nUserPort = temptag.tag.intvalue;
				break;
			//[Bloodymad@Vorlost Anti-Friendsharing 0.3]
			case CT_FRIENDSHARING:
				m_bIsFriendsharingClient = (temptag.tag.intvalue == FRIENDSHARING_ID);
				break;
		}
	}
	m_nUserPort = nUserPort;
	data->Read(&m_dwServerIP,4);
	data->Read(&m_nServerPort,2);
	// Hybrid now has an extra uint32.. What is it for?
	// Also, many clients seem to send an extra 6? These are not eDonkeys or Hybrids..
	if ( data->GetLength() - data->GetPosition() == 4 ){
		uint32 test;
		data->Read(&test,4);
		if (test=='KDLM') 
			m_bIsML=true;
		else{
			m_bIsHybrid = true;
			m_fSharedDirectories = 1;
		}
	}
	if( m_nClientVersion > 10000 && m_nClientVersion < 100000 )
		m_nClientVersion = m_nClientVersion - (m_nClientVersion/10000)*10000;
	if( m_nClientVersion > 1000 )
		m_nClientVersion = m_nClientVersion - (m_nClientVersion/1000)*1000;
	if( m_nClientVersion < 100 )
		m_nClientVersion *= 10;
	// tecxx 1609 2002 - add client's servet to serverlist (Moved to uploadqueue.cpp)

	SOCKADDR_IN sockAddr;
	memset(&sockAddr, 0, sizeof(sockAddr));
	uint32 nSockAddrLen = sizeof(sockAddr);
	socket->GetPeerName((SOCKADDR*)&sockAddr,(int*)&nSockAddrLen);
	

	m_dwUserIP = sockAddr.sin_addr.S_un.S_addr;
	strcpy(m_szFullUserIP,inet_ntoa(sockAddr.sin_addr));

	if (theApp.glob_prefs->AddServersFromClient() && m_dwServerIP && m_nServerPort){
		in_addr addhost;
		addhost.S_un.S_addr = m_dwServerIP;
		CServer* addsrv = new CServer(m_nServerPort, inet_ntoa(addhost));
		addsrv->SetListName(addsrv->GetAddress());

		if (!theApp.emuledlg->serverwnd.serverlistctrl.AddServer(addsrv, true))
			delete addsrv;
	}

	if(!HasLowID() || m_nUserID == 0)
		m_nUserID = m_dwUserIP;

	// get client credits
	uchar key[16];
	md4cpy(key,m_achUserHash);
	CClientCredits* pFoundCredits = theApp.clientcredits->GetCredit(key);
	if (credits == NULL){
		credits = pFoundCredits;
		if (!theApp.clientlist->ComparePriorUserhash(m_dwUserIP, m_nUserPort, pFoundCredits)){
			theApp.emuledlg->AddDebugLogLine(false, "Clients: %s (%s), Banreason: Userhash changed (Found in TrackedClientsList)", GetUserName(), GetFullIP()); 
			Ban();
		}	
	}
	else if (credits != pFoundCredits){
		// userhash change ok, however two hours "waittime" before it can be used
		credits = pFoundCredits;
		theApp.emuledlg->AddDebugLogLine(false, "Clients: %s (%s), Banreason: Userhash changed", GetUserName(),GetFullIP()); 
		Ban();
	}

	if ((m_Friend = theApp.friendlist->SearchFriend(key, m_dwUserIP, m_nUserPort)) != NULL){
		// Link the friend to that client
		if (m_Friend->m_LinkedClient){
			if (m_Friend->m_LinkedClient != this){
				bool bFriendSlot = m_Friend->m_LinkedClient->GetFriendSlot();
				// avoid that an unwanted client instance keeps a friend slot
				m_Friend->m_LinkedClient->SetFriendSlot(false);
				m_Friend->m_LinkedClient->m_Friend = NULL;
				m_Friend->m_LinkedClient = this;
				// move an assigned friend slot between different client instances which are/were also friends
				m_Friend->m_LinkedClient->SetFriendSlot(bFriendSlot);
			}
		}
		else
			m_Friend->m_LinkedClient = this;
		md4cpy(m_Friend->m_abyUserhash,GetUserHash());
		m_Friend->m_dwHasHash = md4cmp(m_Friend->m_abyUserhash, CFriend::sm_abyNullHash) ? 1 : 0;
		m_Friend->m_strName = m_pszUsername;
		m_Friend->m_dwLastUsedIP = m_dwUserIP;
		m_Friend->m_nLastUsedPort = m_nUserPort;
		m_Friend->m_dwLastSeen = time(NULL);
		theApp.friendlist->RefreshFriend(m_Friend);
	}
	else{
		// avoid that an unwanted client instance keeps a friend slot
		SetFriendSlot(false);
	}
	ReGetClientSoft();
	//[Bloodymad@LSD ModIdentify.Receive]
	ReGetClientName();

	m_byInfopacketsReceived |= IP_EDONKEYPROTPACK;
	if (m_byInfopacketsReceived == IP_BOTH)
		InfoPacketsReceived();
}

void CUpDownClient::SendHelloPacket(){
	if (socket == NULL){
		ASSERT(0);
		return;
	}

	// if IP is filtered, dont greet him but disconnect...
	SOCKADDR_IN sockAddr;
	memset(&sockAddr, 0, sizeof(sockAddr));
	uint32 nSockAddrLen = sizeof(sockAddr);
	socket->GetPeerName((SOCKADDR*)&sockAddr,(int*)&nSockAddrLen);
	if ( theApp.ipfilter->IsFiltered(sockAddr.sin_addr.S_un.S_addr)) {
		theApp.emuledlg->AddDebugLogLine(true,GetResString(IDS_IPFILTERED),inet_ntoa(sockAddr.sin_addr),theApp.ipfilter->GetLastHit());
		Disconnected();
		theApp.stat_filteredclients++;
		return;
	}

	CSafeMemFile data(128);
	uint8 hashsize = 16;
	data.Write(&hashsize,1);
	SendHelloTypePacket(&data);
	Packet* packet = new Packet(&data);
	packet->opcode = OP_HELLO;
	theApp.uploadqueue->AddUpDataOverheadOther(packet->size);
	socket->SendPacket(packet,true);
}

void CUpDownClient::SendMuleInfoPacket(bool bAnswer){
	if (socket == NULL){
		ASSERT(0);
		return;
	}

	CSafeMemFile data(128);
	uint8 version = CURRENT_VERSION_SHORT;
	data.Write(&version,1);
	uint8 protversion = EMULE_PROTOCOL;
	data.Write(&protversion,1);
	//[Bloodymad Featureset.Send]
	//[Bloodymad@LSD ModIdentify.Send]
	//[Bloodymad Scoring.EstWaiting.Send]
	// tagcount +1 for Featureset and +1 for ModIdentify
	uint32 tagcount = 9;
	data.Write(&tagcount,4);
	CTag tag(ET_COMPRESSION,1);
	tag.WriteTagToFile(&data);
	CTag tag2(ET_UDPVER,2);
	tag2.WriteTagToFile(&data);
	CTag tag3(ET_UDPPORT,theApp.glob_prefs->GetUDPPort());
	tag3.WriteTagToFile(&data);
	CTag tag4(ET_SOURCEEXCHANGE,2);
	tag4.WriteTagToFile(&data);
	CTag tag5(ET_COMMENTS,1);
	tag5.WriteTagToFile(&data);
	CTag tag6(ET_EXTENDEDREQUEST,1);
	tag6.WriteTagToFile(&data);
	CTag tag7(ET_FEATURES,(uint32)(theApp.clientcredits->CryptoAvailable() ? 3 : 0));
	tag7.WriteTagToFile(&data);
	//[Bloodymad@LSD ModIdentify.Send]
	CTag tag8(ET_MOD_VERSION, MOD_VERSION);
	tag8.WriteTagToFile(&data);
	//[Bloodymad Featureset.Send]
	//[Bloodymad Scoring.EstWaiting.Send]
	CTag tag9(ET_FEATURESET,EF_SENDSWAITTIME);
	tag9.WriteTagToFile(&data);
	Packet* packet = new Packet(&data,OP_EMULEPROT);
	if (!bAnswer)
		packet->opcode = OP_EMULEINFO;
	else
		packet->opcode = OP_EMULEINFOANSWER;
	theApp.uploadqueue->AddUpDataOverheadOther(packet->size);
	socket->SendPacket(packet,true,true);
}

void CUpDownClient::ProcessMuleInfoPacket(char* pachPacket, uint32 nSize){
	//[Bloodymad@LSD ModIdentify.Receive]
	uint8	m_byDataTarodVer = 0; 		// Added by Tarod (just curiosity)
	uint32	m_dwTarodVersionNumber = 0; // Added by Tarod	

	uint8	m_byDataLSDVer = 0; 		// Bool LSD
	uint32	m_dwLSDVersionNumber = 0; 	// Ver LSD

	uint8   m_byDataPlusVer = 0; 		// Bool Plus
	uint32  m_dwPlusVersionNumber = 0; 	// Ver Plus
	
	uint8	m_byDataMorphVer = 0; 		// Bool Morph
	uint32	m_dwMorphVersionNumber = 0;	// Ver Morph

	uint8   m_byDataOxyVer = 0;			// Bool Oxygen
	
	uint8	m_byDataFusionVer = 0; 			// Bool Fusion
	uint32	m_dwFusionVersionNumber = 0;	// Ver Fusion
	char*	m_strFusionVersionString = 0;	// Fusion String
	
	uint8	m_byDataMorTilloVer = 0; 		// Bool MorTillo
	uint32	m_dwMorTilloVersionNumber = 0;	// Ver Fusion
	char*	m_strMorTilloVersionString = 0;	// Ver MorTillo 
	
	char*	m_strLovelaceVersionString = 0;	// Lovelace String
	
	char* 	m_modVerString = 0;			// 0x55 Mod ver Generic String
	//char* 	m_modExtendedString = 0;	// 0x56 Mod ver Extended Mod Protocol

	CSafeMemFile data((BYTE*)pachPacket,nSize);
	m_byCompatibleClient = 0;
	//The version number part of this packet will soon be useless since it is only able to go to v.99.
	//Why the version is a uint8 and why it was not done as a tag like the eDonkey hello packet is not known..
	//Therefore, sooner or later, we are going to have to switch over to using the eDonkey hello packet to set the version.
	//No sense making a third value sent for versions..
	data.Read(&m_byEmuleVersion,1);
	if( m_byEmuleVersion == 0x2B )
		m_byEmuleVersion = 0x22;
	uint8 protversion;
	data.Read(&protversion,1);

	//implicitly supported options by older clients
	if (protversion == EMULE_PROTOCOL) {
		//in the future do not use version to guess about new features

		if(m_byEmuleVersion < 0x25 && m_byEmuleVersion > 0x22)
			m_byUDPVer = 1;

		if(m_byEmuleVersion < 0x25 && m_byEmuleVersion > 0x21)
			m_bySourceExchangeVer = 1;

		if(m_byEmuleVersion == 0x24)
			m_byAcceptCommentVer = 1;

		// Shared directories are requested from eMule 0.28+ because eMule 0.27 has a bug in 
		// the OP_ASKSHAREDFILESDIR handler, which does not return the shared files for a 
		// directory which has a trailing backslash.
		if(m_byEmuleVersion >= 0x28 && !m_bIsML) // MLdonkey currently does not support shared directories
			m_fSharedDirectories = 1;

	} else {
		return;
	}
	m_bEmuleProtocol = true;

	uint32 tagcount;
	data.Read(&tagcount,4);
	for (uint32 i = 0;i < tagcount; i++){
		CTag temptag(&data);
		switch(temptag.tag.specialtag){
			case ET_COMPRESSION:
				// Bits 31- 8: 0 - reserved
				// Bits  7- 0: data compression version
				m_byDataCompVer = temptag.tag.intvalue;
				break;
			case ET_UDPPORT:
				// Bits 31-16: 0 - reserved
				// Bits 15- 0: UDP port
				m_nUDPPort = temptag.tag.intvalue;
				break;
			case ET_UDPVER:
				// Bits 31- 8: 0 - reserved
				// Bits  7- 0: UDP protocol version
				m_byUDPVer = temptag.tag.intvalue;
				break;
			case ET_SOURCEEXCHANGE:
				// Bits 31- 8: 0 - reserved
				// Bits  7- 0: source exchange protocol version
				m_bySourceExchangeVer = temptag.tag.intvalue;
				break;
			case ET_COMMENTS:
				// Bits 31- 8: 0 - reserved
				// Bits  7- 0: comments version
				m_byAcceptCommentVer = temptag.tag.intvalue;
				break;
			case ET_EXTENDEDREQUEST:
				// Bits 31- 8: 0 - reserved
				// Bits  7- 0: extended requests version
				m_byExtendedRequestsVer = temptag.tag.intvalue;
				break;
			case ET_COMPATIBLECLIENT:
				// Bits 31- 8: 0 - reserved
				// Bits  7- 0: compatible client ID
				m_byCompatibleClient = temptag.tag.intvalue;
				break;
			//[Bloodymad Featureset.Receive]
			case ET_FEATURESET:
				m_byFeatureSet = temptag.tag.intvalue;
				break;
			//[Bloodymad@LSD ModIdentify.Receice]
			case ET_MOD_TAROD:	// I insist it do not harm, just curiosity
				m_byDataTarodVer = temptag.tag.intvalue;
				break;
			case ET_MOD_TAROD_VERSION: // lugdunum asked for it -do not remove
				m_dwTarodVersionNumber = temptag.tag.intvalue;
				break;
			case ET_MOD_VERSION: //Mod String 55
				m_modVerString = nstrdup(temptag.tag.stringvalue);
				break;
			//case ET_MOD_PROTOCOL: //Mod Extended Protocol String 56
			//	m_modExtendedString = nstrdup(temptag.tag.stringvalue);
			//	break;
			case ET_MOD_LSD:	// bool LSD-4x
				m_byDataLSDVer = temptag.tag.intvalue;
				break;
			case ET_MOD_LSD_VERSION: // uint32 & bool LSD version
				m_dwLSDVersionNumber = temptag.tag.intvalue;
				break;
			case ET_MOD_PLUS: // emule plus ver
				m_dwPlusVersionNumber = temptag.tag.intvalue;
				m_byDataPlusVer=1;
				break;
			case ET_MOD_Morph:	// Morpheus
				m_byDataMorphVer = temptag.tag.intvalue;
				break;
			case ET_MOD_Morph_VERSION: // Morpheus
				m_dwMorphVersionNumber = temptag.tag.intvalue;
				break;
			case ET_MOD_FUSION:	// Fusion
				m_byDataFusionVer = temptag.tag.intvalue;
				m_dwFusionVersionNumber = 1;
				break;
			case ET_MOD_FUSION_VERSION: // Fusion String
				//m_strFusionVersionString = nstrdup(temptag.tag.stringvalue);
				m_dwFusionVersionNumber = 1;
				break;
			case ET_MOD_MorTillo:	// MorTillo
				m_byDataMorTilloVer = temptag.tag.intvalue;
				m_dwMorTilloVersionNumber = 1;
				break;
			case ET_MOD_MorTillo_VERSION: // MorTillo String
				m_strMorTilloVersionString = nstrdup(temptag.tag.stringvalue);
				m_dwMorTilloVersionNumber = 1;
				break;
			case ET_MOD_LOVELACE_VERSION: // Lovelace String
				m_strLovelaceVersionString = nstrdup(temptag.tag.stringvalue);
				break;
			case ET_MOD_OXY:
				m_byDataOxyVer=1; // Is Oxygen mod
				break;
			case ET_FEATURES:
				// Bits 31- 8: 0 - reserved
				// Bit   7- 0: secure identification
				m_bySupportSecIdent = temptag.tag.intvalue & 3;
				break;
		}
	}
	if( m_byDataCompVer == 0 ){
		m_bySourceExchangeVer = 0;
		m_byExtendedRequestsVer = 0;
		m_byAcceptCommentVer = 0;
		m_nUDPPort = 0;
	}

	//[Bloodymad@LSD ModIdentify.Receive]
	if(GetClientSoft()==SO_EMULE || GetClientSoft()==SO_OLDEMULE){
		CString buffer;
		//Mod generic
		if (m_modVerString) {
#ifdef _DEBUG
			buffer.Format("::GENERIC::%s", m_modVerString);
#else
			buffer.Format(m_modVerString);
#endif
        } else
		//Plus version
		if (m_byDataPlusVer) { 
			if(m_dwPlusVersionNumber) {
				buffer.Format("Plus %x%x", m_dwPlusVersionNumber>>8, (m_dwPlusVersionNumber & 0xFF)+9);
				if (buffer.Right(1)=="9")
					buffer.Delete(buffer.GetLength()-1, 1);
				}
			else {
				buffer.Format("Plus");
				}
		} else
		//LSD Version
		if (m_byDataLSDVer) {
			if (m_dwLSDVersionNumber > 0) {
				buffer.Format("LSD %03x", m_dwLSDVersionNumber);
				//buffer.Remove ('0');
			}
			else {
				if (GetMuleVersion()==0x27)
					buffer.Append("LSD 5a");
				else if (GetMuleVersion()==0x26)
					buffer.Append("LSD 4f");
				else 
					buffer.Append("LSD");
				}
		} else
		//Morph version
		if (m_byDataMorphVer) {
			if (m_dwMorphVersionNumber > 0) {
				buffer.Format("MoRpH %03x", m_dwMorphVersionNumber);
				//buffer.Remove('0');
			} 
			else {
				buffer.Append("MoRpH");
			}
		} else
		//Fusion version
		if (m_byDataFusionVer) {
			if (m_dwFusionVersionNumber && m_strFusionVersionString) {
				buffer.Format("Fusion %s", m_strFusionVersionString);
			} 
			else {
				buffer.Append(".FusioN.");
			}
		} else 
		//MorTillo version
		if (m_byDataMorphVer) {
			if (m_strMorTilloVersionString) {
				buffer.Format("MorTillo %s", m_strMorTilloVersionString);
			}
			else {
				buffer.Append("MorTillo");
			}
		} else
		// Lovelace version
		if (m_strLovelaceVersionString) {
			buffer.Format("lovelace %s", m_strLovelaceVersionString);
		} else
		// Oxygen version
		if (m_byDataOxyVer == 1 || m_byDataOxyVer == 2) {
			buffer.Append("Oxygen");
		} else 
		// Tarod version
		if (m_byDataTarodVer == 1 || m_byDataTarodVer == 2) {
			if (m_dwTarodVersionNumber > 0) {
				buffer.Format("Tarod %03x", m_dwTarodVersionNumber);
				if (buffer.Right(1)=="0")
					buffer.Delete(buffer.GetLength()-1, 1);
			}
			else {
				buffer.Append("Mod"); //is Old Advanced Mod
			}
		}
		if (m_versionModString)
			EMPTYARR(m_versionModString);
		if (!buffer.IsEmpty())
			m_versionModString = nstrdup(buffer.GetBuffer());
	}

	if (m_strFusionVersionString)
		delete[] m_strFusionVersionString;
	if (m_strMorTilloVersionString)
		delete[] m_strMorTilloVersionString;
	if (m_strLovelaceVersionString)
		delete[] m_strLovelaceVersionString;
	if (m_modVerString)
		delete[] m_modVerString;
	//if (m_modExtendedString)
	//	delete[] m_modExtendedString;

	ReGetClientSoft();
	//[Bloodymad@LSD ModIdentify.Receive]
	ReGetClientName();

	m_byInfopacketsReceived |= IP_EMULEPROTPACK;
	if (m_byInfopacketsReceived == IP_BOTH)
		InfoPacketsReceived();
}

void CUpDownClient::SendHelloAnswer(){
	if (socket == NULL){
		ASSERT(0);
		return;
	}

	CSafeMemFile data(128);
	SendHelloTypePacket(&data);
	Packet* packet = new Packet(&data);
	packet->opcode = OP_HELLOANSWER;
	theApp.uploadqueue->AddUpDataOverheadOther(packet->size);
	socket->SendPacket(packet,true);
}

void CUpDownClient::SendHelloTypePacket(CMemFile* data){
	data->Write(theApp.glob_prefs->GetUserHash(),16);
	uint32 clientid = theApp.serverconnect->GetClientID();
	data->Write(&clientid,4);
	uint16 nPort = theApp.glob_prefs->GetPort();
	data->Write(&nPort,2);
	uint32 tagcount = 2;
	data->Write(&tagcount,4);
	CTag tagName(CT_NAME,theApp.glob_prefs->GetUserNick());
	tagName.WriteTagToFile(data);
	CTag tagVersion(CT_VERSION,EDONKEYVERSION);
	tagVersion.WriteTagToFile(data);
	uint32 dwIP;
	if (theApp.serverconnect->IsConnected()){
		dwIP = theApp.serverconnect->GetCurrentServer()->GetIP();
		nPort = theApp.serverconnect->GetCurrentServer()->GetPort();
	}
	else{
		nPort = 0;
		dwIP = 0;
	}
	data->Write(&dwIP,4);
	data->Write(&nPort,2);
}

void CUpDownClient::ProcessMuleCommentPacket(char* pachPacket, uint32 nSize){
	if( reqfile ){
		if( reqfile->IsPartFile()){
			int length;
			if (nSize>(sizeof(m_iRate)+sizeof(length)-1)){
				CSafeMemFile data((BYTE*)pachPacket,nSize);
				data.Read(&m_iRate,sizeof(m_iRate));
				data.Read(&length,sizeof(length));
				reqfile->SetHasRating(true);
				theApp.emuledlg->AddDebugLogLine(false,GetResString(IDS_RATINGRECV),m_strClientFilename,m_iRate);
				if ( length > data.GetLength() - data.GetPosition() ){
					length = data.GetLength() - data.GetPosition();
				}
				if (length>50) length=50;
				if (length>0){
					data.Read(m_strComment.GetBuffer(length),length);
					m_strComment.ReleaseBuffer(length);
					theApp.emuledlg->AddDebugLogLine(false,GetResString(IDS_DESCRIPTIONRECV), m_strClientFilename, m_strComment);
					reqfile->SetHasComment(true);
					
					// test if comment is filtered
					if (theApp.glob_prefs->GetCommentFilter().GetLength()>0) {
						CString resToken;
						CString strlink=theApp.glob_prefs->GetCommentFilter();
						strlink.MakeLower();
						int curPos=0;
						resToken= strlink.Tokenize("|",curPos);
						while (resToken != "") {
							if (m_strComment.MakeLower().Find(resToken)>-1) {
								m_strComment="";
								m_iRate=0;
								reqfile->SetHasRating(false);
								reqfile->SetHasComment(false);
								break;
							}
							resToken= strlink.Tokenize("|",curPos);
						}
		
					}
				}
			}
			if (reqfile->HasRating() || reqfile->HasComment()) theApp.emuledlg->transferwnd.downloadlistctrl.UpdateItem(reqfile);
		}
	}
}

void CUpDownClient::Disconnected(){
	ASSERT(theApp.clientlist->Debug_IsValidClient(this));

	if (GetUploadState() == US_UPLOADING)
		theApp.uploadqueue->RemoveFromUploadQueue(this);
	if (m_BlockSend_queue.GetCount() > 0) {
		// Although this should not happen, it happens sometimes. The problem we may run into here is as follows:
		//
		// 1.) If we do not clear the block send requests for that client, we will send those blocks next time the client
		// gets an upload slot. But because we are starting to send any available block send requests right _before_ the
		// remote client had a chance to prepare to deal with them, the first sent blocks will get dropped by the client.
		// Worst thing here is, because the blocks are zipped and can therefore only be uncompressed when the first block
		// was received, all of those sent blocks will create a lot of uncompress errors at the remote client.
		//
		// 2.) The remote client may have already received those blocks from some other client when it gets the next
		// upload slot.
		theApp.emuledlg->AddDebugLogLine(false, "Disconnected client %u. Block send queue=%u.", GetUserID(), m_BlockSend_queue.GetCount());
		ClearUploadBlockRequests();
	}
	if (GetDownloadState() == DS_DOWNLOADING){
		SetDownloadState(DS_ONQUEUE);
	}
	else if(GetDownloadState() == DS_CONNECTED){
		// client didn't responsed to our request for some reasons (remotely banned?)
		// or it just doesn't has this file, so try to swap first
		if (!SwapToAnotherFile(true, true, true, NULL)){
			theApp.downloadqueue->RemoveSource(this);
			//DEBUG_ONLY(theApp.emuledlg->AddDebugLogLine(false, "Removed %s from downloadqueue - didn't responsed to filerequests",GetUserName()));
		}
	}
		

	// The remote client does not have to answer with OP_HASHSETANSWER *immediatly* 
	// after we've sent OP_HASHSETREQUEST. It may occure that a (buggy) remote client 
	// is sending use another OP_FILESTATUS which would let us change to DL-state to DS_ONQUEUE.
	if (((GetDownloadState() == DS_REQHASHSET) || m_fHashsetRequesting) && (reqfile))
        reqfile->hashsetneeded = true;

	ASSERT(theApp.clientlist->Debug_IsValidClient(this));

	//check if this client is needed in any way, if not delete it
	bool bDelete = true;
	switch(m_nUploadState){
		case US_ONUPLOADQUEUE:
			bDelete = false;
//		default:
//			this->SetUploadFileID(NULL);
	};
	switch(m_nDownloadState){
		case DS_ONQUEUE:
		case DS_TOOMANYCONNS:
		case DS_NONEEDEDPARTS:
		case DS_LOWTOLOWIP:
			bDelete = false;
	};

	switch(m_nUploadState){
		case US_CONNECTING:
		case US_WAITCALLBACK:
		case US_ERROR:
			bDelete = true;
	};
	switch(m_nDownloadState){
		case DS_CONNECTING:
		{
			m_cFailed++;
			if (m_cFailed <= 2){
				TryToConnect();
				return;
			}
		}
		case DS_WAITCALLBACK:
		case DS_ERROR:
			bDelete = true;
	};
	

	if (GetChatState() != MS_NONE){
		bDelete = false;
		theApp.emuledlg->chatwnd.chatselector.ConnectingResult(this,false);
	}
	if (socket){
		ASSERT (theApp.listensocket->IsValidSocket(socket));
		socket->Safe_Delete();
	}
	socket = 0;
    if (m_iFileListRequested){
		theApp.emuledlg->AddDebugLogLine(false,GetResString(IDS_SHAREDFILES_FAILED),GetUserName());
        m_iFileListRequested = 0;
	}
	if (m_Friend)
		theApp.friendlist->RefreshFriend(m_Friend);
	theApp.emuledlg->transferwnd.clientlistctrl.RefreshClient(this);
	if (bDelete){
		delete this;
	}
	else{
		m_fHashsetRequesting = 0;
		m_dwEnteredConnectedState = 0;
	}
}

bool CUpDownClient::TryToConnect(bool bIgnoreMaxCon){
	if (theApp.listensocket->TooManySockets() && !bIgnoreMaxCon && !(socket && socket->IsConnected())){
		Disconnected();
		return false;
	}

	if ((theApp.serverconnect->GetClientID() < 16777216) && HasLowID()){
		if (GetDownloadState() == DS_CONNECTING)
			SetDownloadState(DS_LOWTOLOWIP);
		else if (GetDownloadState() == DS_REQHASHSET){
			SetDownloadState(DS_ONQUEUE);
			reqfile->hashsetneeded = true;
		}
		if (GetUploadState() == US_CONNECTING){
			Disconnected();
			return false;
		}
	}

	if (!socket){
		socket = new CClientReqSocket(theApp.glob_prefs,this);
		if (!socket->Create()){
			socket->Safe_Delete();
			return true;
		}
	}
	else if (!socket->IsConnected()){
		socket->Safe_Delete();
		socket = new CClientReqSocket(theApp.glob_prefs,this);
		if (!socket->Create()){
			socket->Safe_Delete();
			return true;
		}
	}
	else{
		ConnectionEstablished();
		return true;
	}
	// MOD Note: Do not change this part - Merkur
	if (HasLowID()){
		if (GetDownloadState() == DS_CONNECTING)
			SetDownloadState(DS_WAITCALLBACK);
		if (GetUploadState() == US_CONNECTING){
			Disconnected();
			return false;
		}

		if (theApp.serverconnect->IsLocalServer(m_dwServerIP,m_nServerPort)){
			Packet* packet = new Packet(OP_CALLBACKREQUEST,4);
			memcpy(packet->pBuffer,&m_nUserID,4);
			theApp.uploadqueue->AddUpDataOverheadServer(packet->size);
			theApp.serverconnect->SendPacket(packet);
		}
		else{
			if (GetUploadState() == US_NONE && (!GetRemoteQueueRank() || m_bReaskPending) ){
				theApp.downloadqueue->RemoveSource(this);
				Disconnected();
				return false;
			}
			else{
				if (GetDownloadState() == DS_WAITCALLBACK){
					m_bReaskPending = true;
					SetDownloadState(DS_ONQUEUE);
				}
			}
		}
	}
	// MOD Note - end
	else{
		socket->Connect(GetFullIP(),GetUserPort());
		SendHelloPacket();
	}

	return true;
}

void CUpDownClient::ConnectionEstablished(){
	m_cFailed = 0;
	// ok we have a connection, lets see if we want anything from this client
	if (GetChatState() == MS_CONNECTING)
		theApp.emuledlg->chatwnd.chatselector.ConnectingResult(this,true);
	switch(GetDownloadState()){
		case DS_CONNECTING:
		case DS_WAITCALLBACK:
			m_bReaskPending = false;
			SetDownloadState(DS_CONNECTED);
			SendFileRequest();
	}
	if (m_bReaskPending){
		m_bReaskPending = false;
		if (GetDownloadState() != DS_NONE && GetDownloadState() != DS_DOWNLOADING){
			SetDownloadState(DS_CONNECTED);
			SendFileRequest();
		}
	}
	switch(GetUploadState()){
		case US_CONNECTING:
		case US_WAITCALLBACK:
			if (theApp.uploadqueue->IsDownloading(this)){
				SetUploadState(US_UPLOADING);
				Packet* packet = new Packet(OP_ACCEPTUPLOADREQ,0);
				theApp.uploadqueue->AddUpDataOverheadFileRequest(packet->size);
				socket->SendPacket(packet,true);
			}
	}
    if (m_iFileListRequested == 1){
        Packet* packet = new Packet(m_fSharedDirectories ? OP_ASKSHAREDDIRS : OP_ASKSHAREDFILES,0);
		theApp.uploadqueue->AddUpDataOverheadOther(packet->size);
		socket->SendPacket(packet,true,true);
	}
}

void CUpDownClient::ReGetClientSoft(){
	if (!m_pszUsername) {m_clientSoft=SO_UNKNOWN;return;}
	int iHashType = GetHashType();
	if (iHashType == SO_OLDEMULE) {m_clientSoft= SO_OLDEMULE;return;}
	if (iHashType == SO_EMULE){
		if( m_byEmuleVersion!=0x99 ){
			CString temp;
			temp.Format( "%02X", m_byEmuleVersion );
			m_nClientVersion = 	atoi(temp.GetBuffer())*10;
		}
		switch(m_byCompatibleClient){
			case SO_CDONKEY:
				m_clientSoft = SO_CDONKEY;
				break;
			case SO_XMULE:
				m_clientSoft = SO_XMULE;
				break;
			case SO_SHAREAZA:
				m_clientSoft = SO_SHAREAZA;
				break;
			default:
				if (m_bIsML)
					m_clientSoft = SO_MLDONKEY;
				else if (m_bIsHybrid)
					m_clientSoft = SO_EDONKEYHYBRID;
				else
					m_clientSoft = SO_EMULE;
		}
		return;
	}
	if (m_bIsML || iHashType == SO_MLDONKEY) {m_clientSoft= SO_MLDONKEY;return;}
	if( m_bIsHybrid )
		m_clientSoft=SO_EDONKEYHYBRID;
	else
		m_clientSoft=SO_EDONKEY;
}

void CUpDownClient::ReGetClientName(){
	//[Bloodymad@LSD ModIdentify.Receive]
	CString buffer;
	switch(GetClientSoft()){
		case SO_EMULE:
		case SO_OLDEMULE:{
			//buffer.Format("eMule v%02X", GetMuleVersion());
			buffer.Format("eMule v%.2f",(float)GetVersion()/1000.0f);
			break;
		} //END SO_EMULE Case
		case SO_EDONKEY:
			//buffer.Format("eDonkey v%i", GetVersion());
			buffer.Format("eDonkey v%.1f", (float)GetVersion()/10.0f);
			break;
		case SO_EDONKEYHYBRID:
			//buffer.Format( "dHybrid v%i", GetVersion());
			//buffer.Format( "dHybrid v%.2f", (float)GetVersion()/10.0f);
			buffer.Format( "dHybrid v%.1f", (float)GetVersion()/10.0f);
			//buffer.Remove ('0');
			break;
		case SO_CDONKEY:{
			buffer.Format("cDonkey v%.2f",(float)GetVersion()/1000.0f);
			break;
			}
		case SO_XMULE:{
			buffer.Format("xMule v%.2f",(float)GetVersion()/1000.0f);
			break;
			}
		case SO_MLDONKEY:
			buffer.Format("MLdonkey v%.2f",(float)GetVersion()/1000.0f);
			break;
		case SO_SHAREAZA:
			buffer.Format("Shareaza v%.2f",(float)GetVersion()/1000.0f);
			break;
		case SO_UNKNOWN:
		default:
			buffer = GetResString(IDS_UNKNOWN);
	} //END switch

	if (m_versionModString)
		buffer.AppendFormat(" [%s]",m_versionModString);

	ASSERT(m_versionString);
#ifdef DEBUG
	buffer.AppendFormat(" <%s>",m_versionString);
#endif
	EMPTYARR(m_versionString);
	m_versionString = nstrdup(buffer.GetBuffer());
}

int CUpDownClient::GetHashType()
{
	if (m_achUserHash[5] == 13 && m_achUserHash[14] == 110)
		return SO_OLDEMULE;
	else if (m_achUserHash[5] == 14 && m_achUserHash[14] == 111)
		return SO_EMULE;
 	else if (m_achUserHash[5] == 'M' && m_achUserHash[14] == 'L')
		return SO_MLDONKEY;
	else
		return SO_UNKNOWN;
}

void CUpDownClient::SetUserName(char* pszNewName){
	if (m_pszUsername){
		delete[] m_pszUsername;
		m_pszUsername = NULL;// needed, in case 'nstrdup' fires an exception!!
	}
	 //[Bloodymad NickGenerator]
	if (pszNewName){ 
		if ((strncmp(pszNewName,"http://emule-project.net",24)==0) || 
			(strncmp(pszNewName,"http://www.emule.de",19)==0) ||
			(strncmp(pszNewName,"http://www.emule-project.net",28)==0) ||
			(strncmp(pszNewName,"http://emule-france.com",23)==0) ||
			(strncmp(pszNewName,"eMule v0.",9)==0)
			//|| (strncmp(pszNewName,"eMule Plus v0.",14)==0)
			//|| (strncmp(pszNewName,"Emule Morph",11)==0)
			// It's maybe not fair to patch out other program's names
			)
		{
			m_pszUsername = new char[21]; 
			GenerateNickName(8,m_pszUsername); 
			strcat(m_pszUsername, " [generated]"); 
		} 
		else
			m_pszUsername = nstrdup(pszNewName);
	}
}

//[Bloodymad AntiMisonMax]
bool CUpDownClient::SendStrMessage(char* msg) {
	if (!(socket && GetUploadState()))
	  return false;
	uint16 mlen = (uint16)strlen(msg);
	Packet* packet = new Packet(OP_MESSAGE,mlen+2);
	memcpy(packet->pBuffer,&mlen,2);
	memcpy(packet->pBuffer+2,msg,mlen);
	socket->SendPacket(packet,true,true);
	return true;
}

//[Bloodymad NickGenerator]
// Helper function for GenerateNickName
// Get the number of ones in the binary representation of map
int count1s(uint32 map) {
	int count = 0;
	while (map) {
		// The compiler will optimize it...
		count += map%2;
		map /=2;
	}
	return count;
}

// Helper function for GenerateNickName
// Get the index of the counts "one" in the binary representation of map
int get1index(int32 map, int count) {
	int index = -1;
	while (count) {
		index++;
		count -= map%2;
		map /= 2;
	}
	return index;
}

// Generates a random nickname that looks a bit like english.
// Needs |nicklen>=2|.
// |nick| has to provide enough space for the generated name.
void CUpDownClient::GenerateNickName(const int nicklen, char* nick) {
	ASSERT(nicklen>=2);

	// English language statistics (from /usr/dict/words). Less then 3Kb.
	// Statistics version 2.0
	// Every bit represents a bigram. 1 = possible, 0 = impossible

	// Bigrams on word beginnings
	const uint32 BeginBigramTable[26] =
		{1488910, 1198353, 149633, 1196305, 10663936, 1198353, 1198353, 17842449, 143360, 1065233, 155921, 1065233, 1065233, 1065233, 436262, 1198481, 1048576, 1065233, 1622421, 1196433, 964608, 16657, 147857, 16777489, 1065233, 16657};
	// Trigrams
	const uint32 TrigramTable[26][26] = {
		{1456197, 18705, 17302932, 2248985, 1468485, 540720, 1204561, 22801, 927752, 16401, 16777489, 542993, 53523, 794973, 1972612, 835985, 1048576, 17432861, 819600, 541072, 927820, 16657, 142371, 20988177, 5003283, 50348305},
		{927748, 16795921, 16385, 1196305, 927753, 1048576, 16384, 1064976, 927757, 1048592, 16, 1065233, 4194576, 16401, 1206281, 147456, 16, 1065233, 1589524, 1198129, 927748, 272, 16, 16, 38701200, 16},
		{960514, 393232, 1198353, 16405, 960513, 1, 1196304, 1196305, 976921, 16, 17041683, 1065233, 1048849, 17842449, 1193984, 1048705, 1048576, 17842449, 811264, 1196305, 923648, 16, 16, 16, 690181, 17},
		{17447172, 17844497, 1067137, 16779537, 407556, 1198337, 16, 16657, 811013, 1064977, 272, 16657, 16657, 16657, 5388356, 149905, 1048576, 1065233, 577936, 16785, 440325, 16657, 16657, 16, 276499, 1048576},
		{932874, 1196049, 1721745, 1196377, 699400, 1722673, 1196369, 1196305, 796744, 1064977, 786705, 18713, 49427, 786717, 1226764, 674193, 1048576, 17723665, 819476, 672145, 954372, 16657, 278801, 573717, 4485137, 50348048},
		{928004, 273, 5, 16385, 927749, 149777, 129, 17, 927772, 16384, 1, 17842449, 5, 256, 1198080, 131076, 16, 1065233, 574609, 21250192, 403456, 16, 1, 16, 16, 16},
		{931842, 16657, 16, 16401, 944129, 1179920, 16779537, 540689, 813063, 1, 16640, 17842449, 1048593, 1065233, 1992712, 18704, 16, 16657, 541059, 16769, 407825, 16, 16924689, 16, 176128, 1},
		{669696, 1198097, 147585, 147713, 407553, 1065217, 16401, 16401, 960516, 16, 16656, 16657, 16657, 1327377, 1996800, 1067265, 1048576, 1065233, 541061, 17060272, 929858, 256, 16785, 16, 956424, 16},
		{665602, 1181970, 1590673, 345, 3024908, 17301808, 139729, 273, 257, 1065233, 16657, 2329, 53523, 786781, 1056768, 838033, 1048576, 677917, 807316, 18366865, 266240, 273, 16641, 540944, 1, 33570833},
		{143364, 16, 16, 16, 5120037, 16, 16, 16, 538688, 16, 16, 16, 16, 16, 18229636, 16, 16, 16, 16, 16, 403528, 16, 16, 16, 16, 16},
		{17442888, 1196305, 131457, 147473, 17704976, 1065233, 147457, 675857, 931864, 1, 24593, 16657, 16401, 1065233, 7481384, 18689, 16, 17842449, 1626496, 147841, 165896, 16, 16657, 16, 5655185, 16},
		{929796, 1198353, 1065361, 409872, 17707077, 1196305, 147729, 16657, 794693, 16384, 21234065, 17842449, 278801, 1064976, 5922884, 672145, 16, 17842193, 541073, 16925073, 929812, 273, 16657, 16, 831620, 17},
		{927812, 1198353, 9548, 147472, 927752, 1067280, 16, 1064976, 796684, 16, 16, 16657, 17842449, 16657, 1976328, 1722513, 1048576, 278529, 17355156, 147600, 931840, 16, 16657, 16, 933908, 16},
		{665600, 1198097, 541073, 1458449, 21891077, 1198353, 1984785, 16793873, 794693, 1064977, 17041713, 16657, 16657, 17842449, 6174724, 1067280, 1048576, 17842433, 1622289, 147857, 800789, 16657, 16785, 524544, 284675, 16777489},
		{925708, 280851, 1721749, 17844505, 3025162, 540961, 17956945, 28945, 403468, 16657, 17039633, 17844505, 53523, 803165, 539688, 17351057, 1048576, 17314073, 819473, 541073, 925760, 273, 272403, 16777620, 18461, 50348049},
		{927748, 1460241, 16512, 163841, 665613, 1181968, 131073, 16793873, 927773, 17, 272, 1065233, 1064977, 16400, 928000, 16926993, 16, 16657, 18366736, 1065217, 927744, 4, 147713, 16, 657474, 16},
		{524288, 16, 16, 16, 8, 16, 16, 16, 16, 16, 16, 16, 16, 16, 16, 16, 16, 16, 16, 16, 273, 16, 16, 16, 16, 16},
		{571660, 1065233, 1065361, 278801, 794653, 1198353, 17844497, 16793873, 811037, 1064976, 17062161, 16793873, 16657, 16657, 6092804, 934289, 1048576, 16793873, 1589649, 17842577, 831758, 16657, 16657, 16, 317449, 16657},
		{665606, 17842449, 1196433, 1196289, 931861, 1065233, 1458448, 147729, 2910223, 1048576, 17826065, 1065233, 1065233, 1065233, 1193988, 149905, 1048576, 1327377, 16657, 147729, 440322, 33040, 16657, 16, 407556, 2304},
		{665858, 1196305, 129, 147456, 403472, 1065217, 1196049, 16924945, 2646021, 16, 16777489, 273, 1065233, 1589521, 176128, 149777, 16, 17842449, 5788048, 16795921, 929801, 257, 16657, 16, 165888, 448849},
		{927752, 1968403, 527764, 262489, 927746, 32, 1048785, 8225, 927756, 1065217, 131344, 788753, 37139, 525660, 1703936, 952720, 1048576, 926033, 786837, 541073, 4096, 131344, 17, 1591568, 3147793, 33570833},
		{927812, 16, 16, 1, 403456, 16, 16, 32, 813085, 16, 128, 16385, 16, 16, 1706244, 16, 16, 16400, 1024, 16, 407552, 16777488, 16, 16, 4194560, 16384},
		{17704960, 147473, 1065089, 17973520, 403729, 1067265, 256, 16657, 796748, 16, 20979968, 16777489, 16657, 21922192, 153600, 1067281, 16, 16793873, 4774032, 1065361, 178304, 16, 16385, 16, 30737, 16777216},
		{800836, 1048576, 1198481, 16, 407620, 16384, 1050624, 1065217, 290845, 16, 16, 16, 16, 1, 663616, 149777, 1048576, 16, 16, 1196305, 165899, 256, 16400, 16384, 133184, 16},
		{141324, 1196313, 18833, 131089, 927753, 1181969, 16931088, 16924688, 303128, 1, 8720, 2115857, 57617, 540701, 2008160, 934288, 1048576, 1065233, 786704, 16784, 306372, 17, 147857, 256, 16, 16777233},
		{141378, 16, 16, 1, 927745, 16, 16, 16, 194644, 16, 16, 16793616, 1, 16, 192793, 1, 16, 16385, 5, 16, 132116, 16400, 16400, 16, 4162, 16779537}
	};
	// Bigrams on word endings
	const uint32 EndBigramTable[26] =
		{17446920, 17056017, 17302672, 16793617, 17704968, 17301552, 16793744, 17317905, 796701, 1196305, 16777489, 16779289, 16810003, 17301593, 4857856, 17563793, 16, 17309721, 17567888, 16777360, 792592, 17, 16787473, 17301776, 292881, 16793617};

	char c,cl,cll;

	nick[nicklen] = '\0';

	uchar* uhash = GetUserHash();
	ASSERT(uhash);

	// hashing the user hash down to a unsigned int (for srand)
	unsigned int seed = 0;
	for (int i=sizeof(seed);i<=sizeof(uhash);i+=sizeof(seed),uhash+=sizeof(seed))
		seed ^= *((unsigned int*)uhash);
	// Initialize the random generator with the user hash
	srand(seed);

	// First character
	cll = rand()%26;
	nick[0] = (char)cll+97; // 97=='a'

	// Second character
	cl = get1index(BeginBigramTable[cll],1+rand()%count1s(BeginBigramTable[cll]));
	nick[1] = (char)cl+97;

	// Characters three to n-1
	for (int i=2;i<nicklen-1;i++) {
		c = get1index(TrigramTable[cll][cl],1+rand()%count1s(TrigramTable[cll][cl]));
		nick[i] = (char)c+97;
		cll = cl;
		cl = c;
	}

	// Last character
	uint32 tableentry = TrigramTable[cll][cl]&EndBigramTable[cl];
	if (tableentry==0)
		tableentry = EndBigramTable[cl];
	c = get1index(tableentry,1+rand()%count1s(tableentry));
	nick[nicklen-1] = (char)c+97;
}

void CUpDownClient::RequestSharedFileList(){
	if (m_iFileListRequested == 0){
		theApp.emuledlg->AddDebugLogLine(true,GetResString(IDS_SHAREDFILES_REQUEST),GetUserName());
    	m_iFileListRequested = 1;
		TryToConnect(true);
	}
	else
		theApp.emuledlg->AddDebugLogLine(true,_T("Requesting shared files from user %s (%u) is already in progress"),GetUserName(),GetUserID());
}

void CUpDownClient::ProcessSharedFileList(char* pachPacket, uint32 nSize, LPCTSTR pszDirectory){
    if (m_iFileListRequested > 0){
        m_iFileListRequested--;
		theApp.searchlist->ProcessSearchanswer(pachPacket,nSize,this,pszDirectory);
	}
}

void CUpDownClient::SetUserHash(uchar* m_achTempUserHash){
	if( m_achTempUserHash == NULL ){
		md4clr(m_achUserHash);
		return;
	}
	md4cpy(m_achUserHash,m_achTempUserHash);
}

//[Bloodymad@LSD ModIdentify.Receive]
int CUpDownClient::CompareVersion(CUpDownClient *client) {
	ASSERT(client);
	ASSERT(GetVersionString());
	ASSERT(client->GetVersionString());
	if (GetClientSoft()==client->GetClientSoft())
		return strcmp(GetVersionString(),client->GetVersionString());
	return client->GetClientSoft()-GetClientSoft();
}

void CUpDownClient::SendPublicKeyPacket(){
	///* delete this line later*/ DEBUG_ONLY(theApp.emuledlg->AddDebugLogLine(false, "sending public key to '%s'", GetUserName()));
	// send our public key to the client who requested it
	if (socket == NULL || credits == NULL || m_SecureIdentState != IS_KEYANDSIGNEEDED){
		ASSERT ( false );
		return;
	}
	if (!theApp.clientcredits->CryptoAvailable())
		return;

    Packet* packet = new Packet(OP_PUBLICKEY,theApp.clientcredits->GetPubKeyLen() + 1,OP_EMULEPROT);
	theApp.uploadqueue->AddUpDataOverheadOther(packet->size);
	memcpy(packet->pBuffer+1,theApp.clientcredits->GetPublicKey(), theApp.clientcredits->GetPubKeyLen());
	packet->pBuffer[0] = theApp.clientcredits->GetPubKeyLen();
	socket->SendPacket(packet,true,true);
	m_SecureIdentState = IS_SIGNATURENEEDED;
}

void CUpDownClient::SendSignaturePacket(){
	// signate the public key of this client and send it
	if (socket == NULL || credits == NULL || m_SecureIdentState == 0){
		ASSERT ( false );
		return;
	}

	if (!theApp.clientcredits->CryptoAvailable())
		return;
	if (credits->GetSecIDKeyLen() == 0)
		return; // We don't have his public key yet, will be back here later
		///* delete this line later*/ DEBUG_ONLY(theApp.emuledlg->AddDebugLogLine(false, "sending signature key to '%s'", GetUserName()));
	// do we have a challenge value recieved (actually we should if we are in this function)
	if (credits->m_dwCryptRndChallengeFrom == 0){
		theApp.emuledlg->AddDebugLogLine(false, "Want to send signature but challenge value is invalid ('%s')", GetUserName());
		return;
	}
	// v2
	// we will use v1 as default, except if only v2 is supported
	bool bUseV2;
	if ( (m_bySupportSecIdent&1) == 1 )
		bUseV2 = false;
	else
		bUseV2 = true;

	uint8 byChaIPKind = 0;
	uint32 ChallengeIP = 0;
	if (bUseV2){
		if (theApp.serverconnect->GetClientID() == 0 || theApp.serverconnect->IsLowID()){
			// we cannot do not know for sure our public ip, so use the remote clients one
			ChallengeIP = GetIP();
			byChaIPKind = CRYPT_CIP_REMOTECLIENT;
		}
		else{
			ChallengeIP = theApp.serverconnect->GetClientID();
			byChaIPKind  = CRYPT_CIP_LOCALCLIENT;
		}
	}
	//end v2
	uchar achBuffer[250];
	uint8 siglen = theApp.clientcredits->CreateSignature(credits, achBuffer,  250, ChallengeIP, byChaIPKind );
	if (siglen == 0){
		ASSERT ( false );
		return;
	}
	Packet* packet = new Packet(OP_SIGNATURE,siglen + 1+ ( (bUseV2)? 1:0 ),OP_EMULEPROT);
	theApp.uploadqueue->AddUpDataOverheadOther(packet->size);
	memcpy(packet->pBuffer+1,achBuffer, siglen);
	packet->pBuffer[0] = siglen;
	if (bUseV2)
		packet->pBuffer[1+siglen] = byChaIPKind;
	socket->SendPacket(packet,true,true);
	m_SecureIdentState = IS_ALLREQUESTSSEND;
}

void CUpDownClient::ProcessPublicKeyPacket(uchar* pachPacket, uint32 nSize){
	theApp.clientlist->AddTrackClient(this);

	///* delete this line later*/ DEBUG_ONLY(theApp.emuledlg->AddDebugLogLine(false, "recieving public key from '%s'", GetUserName()));
	if (socket == NULL || credits == NULL || pachPacket[0] != nSize-1
		|| nSize == 0 || nSize > 250){
		ASSERT ( false );
		return;
	}
	if (!theApp.clientcredits->CryptoAvailable())
		return;
	// the function will handle everything (mulitple key etc)
	if (credits->SetSecureIdent(pachPacket+1, pachPacket[0])){
		// if this client wants a signature, now we can send him one
		if (m_SecureIdentState == IS_SIGNATURENEEDED){
			SendSignaturePacket();
		}
		else if(m_SecureIdentState == IS_KEYANDSIGNEEDED){
			// something is wrong
			theApp.emuledlg->AddDebugLogLine(false, "Invalid State error: IS_KEYANDSIGNEEDED in ProcessPublicKeyPacket");
		}
	}
	else{
		theApp.emuledlg->AddDebugLogLine(false, "Failed to use new recieved public key");
	}
}

void CUpDownClient::ProcessSignaturePacket(uchar* pachPacket, uint32 nSize){
	///* delete this line later*/ DEBUG_ONLY(theApp.emuledlg->AddDebugLogLine(false, "receiving signature from '%s'", GetUserName()));
	// here we spread the good guys from the bad ones ;)

	if (socket == NULL || credits == NULL || nSize == 0 || nSize > 250){
		ASSERT ( false );
		return;
	}

	uint8 byChaIPKind;
	if (pachPacket[0] == nSize-1)
		byChaIPKind = 0;
	else if (pachPacket[0] == nSize-2 && (m_bySupportSecIdent & 2) > 0) //v2
		byChaIPKind = pachPacket[nSize-1];
	else{
		ASSERT ( false );
		return;
	}

	if (!theApp.clientcredits->CryptoAvailable())
		return;
	
	// we accept only one signature per IP, to avoid floods which need a lot cpu time for cryptfunctions
	if (m_dwLastSignatureIP == GetIP()){
		theApp.emuledlg->AddDebugLogLine(false, "recieved multiple signatures from one client");
		return;
	}
	// also make sure this client has a public key
	if (credits->GetSecIDKeyLen() == 0){
		theApp.emuledlg->AddDebugLogLine(false, "recieved signature for client without public key");
		return;
	}
	// and one more check: did we ask for a signature and sent a challange packet?
	if (credits->m_dwCryptRndChallengeFor == 0){
		theApp.emuledlg->AddDebugLogLine(false, "recieved signature for client with invalid challenge value ('%s')", GetUserName());
		return;
	}

	if (theApp.clientcredits->VerifyIdent(credits, pachPacket+1, pachPacket[0], GetIP(), byChaIPKind ) ){
		// result is saved in function abouve
		//theApp.emuledlg->AddDebugLogLine(false, "'%s' has passed the secure identification, V2 State: %i", GetUserName(), byChaIPKind);
	}
	else
		theApp.emuledlg->AddDebugLogLine(false, "'%s' has failed the secure identification, V2 State: %i", GetUserName(), byChaIPKind);
	m_dwLastSignatureIP = GetIP(); 
}

void CUpDownClient::SendSecIdentStatePacket(){
	// check if we need public key and signature
	uint8 nValue = 0;
	if (credits){
		if (theApp.clientcredits->CryptoAvailable()){
			if (credits->GetSecIDKeyLen() == 0)
				nValue = IS_KEYANDSIGNEEDED;
			else if (m_dwLastSignatureIP != GetIP())
				nValue = IS_SIGNATURENEEDED;
		}
		if (nValue == 0){
			//DEBUG_ONLY(theApp.emuledlg->AddDebugLogLine(false, "Not sending SecIdentState Packet, because State is Zero"));
			return;
		}
		// crypt: send random data to sign
		uint32 dwRandom = rand()+1;
		credits->m_dwCryptRndChallengeFor = dwRandom;
		//DEBUG_ONLY(theApp.emuledlg->AddDebugLogLine(false, "sending SecIdentState Packet, state: %i (to '%s')", nValue, GetUserName() ));
		Packet* packet = new Packet(OP_SECIDENTSTATE,5,OP_EMULEPROT);
		theApp.uploadqueue->AddUpDataOverheadOther(packet->size);
		packet->pBuffer[0] = nValue;
		memcpy(packet->pBuffer+1,&dwRandom, sizeof(dwRandom));
		socket->SendPacket(packet,true,true);
	}
	else
		ASSERT ( false );
}

void CUpDownClient::ProcessSecIdentStatePacket(uchar* pachPacket, uint32 nSize){
	if (nSize != 5)
		return;
	if (!credits){
		ASSERT ( false );
		return;
	}
	switch(pachPacket[0]){
			case 0:
				m_SecureIdentState = IS_UNAVAILABLE;
				break;
			case 1:
				m_SecureIdentState = IS_SIGNATURENEEDED;
				break;
			case 2:
				m_SecureIdentState = IS_KEYANDSIGNEEDED;
				break;
		}
	uint32 dwRandom;
	memcpy(&dwRandom, pachPacket+1,4);
	credits->m_dwCryptRndChallengeFrom = dwRandom;
	//DEBUG_ONLY(theApp.emuledlg->AddDebugLogLine(false, "recieved SecIdentState Packet, state: %i", pachPacket[0]));
}

void CUpDownClient::InfoPacketsReceived(){
	// indicates that both Information Packets has been received
	// needed for actions, which process data from both packets
	ASSERT ( m_byInfopacketsReceived == IP_BOTH );
	m_byInfopacketsReceived = IP_NONE;
	
	if (m_bySupportSecIdent){
		SendSecIdentStatePacket();
	}
}

void CUpDownClient::ResetFileStatusInfo(){
	if (m_abyPartStatus){
		delete[] m_abyPartStatus;
		m_abyPartStatus = NULL;
	}
	m_nPartCount = 0;
	m_strClientFilename = "";
	m_bCompleteSource = false;
	m_dwLastAskedTime = 0;
	m_iRate=0;
	m_strComment="";
}

bool CUpDownClient::IsBanned(){
	return ( (theApp.clientlist->IsBannedClient(GetIP()) ) && m_nDownloadState != DS_DOWNLOADING);
}
