//This program is distributed in the hope that it will be useful,
//but WITHOUT ANY WARRANTY; without even the implied warranty of
//MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//GNU General Public License for more details.
//
//You should have received a copy of the GNU General Public License
//along with this program; if not, write to the Free Software
//Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

//[Bloodymad UsageLog]

#include "StdAfx.h"
#include "UsageLog.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

CUsageLog::CUsageLog(char *logfilename, bool startenabled) {
	logfile = NULL;
	if (logfilename)
		filename = nstrdup(logfilename);
	else
		filename = NULL;
	if (startenabled)
		OpenLog();
}

CUsageLog::~CUsageLog() {
	if (logfile)
		CloseLog();
	if (filename)
		free(filename);
}

void CUsageLog::LogLine(CString action, CString params,...) {
	if (!logfile)
		return;
	ASSERT(action.GetLength()<70);
	CString buf1, buf2;
	va_list argptr;
	va_start(argptr, params);
	buf1.FormatV(params, argptr);
	va_end(argptr);

	buf2.Format("%s: time=%u; %s\n",action,::GetTickCount(),buf1.GetBuffer());
	logfile->Write(buf2.GetBuffer(),buf2.GetLength());
}

void CUsageLog::OpenLog() {
	if (logfile || !filename)
		return;
	logfile = new CFile(filename,CFile::modeCreate|CFile::modeNoTruncate|CFile::modeWrite);
	LogLine("StartSession","");
}

void CUsageLog::CloseLog() {
	if (!logfile)
		return;
	LogLine("EndSession","");
	logfile->Close();
	delete logfile;
	logfile = NULL;
}

